Index: trunk/packages/sipb-xen-www/code/main.py
===================================================================
--- trunk/packages/sipb-xen-www/code/main.py	(revision 566)
+++ trunk/packages/sipb-xen-www/code/main.py	(revision 572)
@@ -42,5 +42,5 @@
 import validation
 import cache_acls
-from webcommon import InvalidInput, CodeError, g
+from webcommon import InvalidInput, CodeError, state
 import controls
 
@@ -120,13 +120,13 @@
 DEFAULT_HEADERS = {'Content-Type': 'text/html'}
 
-def error(op, user, fields, err, emsg):
+def error(op, username, fields, err, emsg):
     """Print an error page when a CodeError occurs"""
-    d = dict(op=op, user=user, errorMessage=str(err),
+    d = dict(op=op, user=username, errorMessage=str(err),
              stderr=emsg)
     return templates.error(searchList=[d])
 
-def invalidInput(op, user, fields, err, emsg):
+def invalidInput(op, username, fields, err, emsg):
     """Print an error page when an InvalidInput exception occurs"""
-    d = dict(op=op, user=user, err_field=err.err_field,
+    d = dict(op=op, user=username, err_field=err.err_field,
              err_value=str(err.err_value), stderr=emsg,
              errorMessage=str(err))
@@ -143,47 +143,23 @@
     return False
 
-def parseCreate(user, fields):
-    name = fields.getfirst('name')
-    if not validation.validMachineName(name):
-        raise InvalidInput('name', name, 'You must provide a machine name.  Max 22 chars, alnum plus \'-\' and \'_\'.')
-    name = name.lower()
-
-    if Machine.get_by(name=name):
-        raise InvalidInput('name', name,
-                           "Name already exists.")
-
-    owner = validation.testOwner(user, fields.getfirst('owner'))
-
-    memory = fields.getfirst('memory')
-    memory = validation.validMemory(owner, memory, on=True)
-
-    disk_size = fields.getfirst('disk')
-    disk_size = validation.validDisk(owner, disk_size)
-
-    vm_type = fields.getfirst('vmtype')
-    vm_type = validation.validVmType(vm_type)
-
-    cdrom = fields.getfirst('cdrom')
-    if cdrom is not None and not CDROM.get(cdrom):
-        raise CodeError("Invalid cdrom type '%s'" % cdrom)
-
-    clone_from = fields.getfirst('clone_from')
-    if clone_from and clone_from != 'ice3':
-        raise CodeError("Invalid clone image '%s'" % clone_from)
-
-    return dict(contact=user, name=name, memory=memory, disk_size=disk_size,
-                owner=owner, machine_type=vm_type, cdrom=cdrom, clone_from=clone_from)
-
-def create(user, fields):
+def parseCreate(username, state, fields):
+    kws = dict([(kw, fields.getfirst(kw)) for kw in 'name owner memory disksize vmtype cdrom clone_from'.split()])
+    validate = validation.Validate(username, state, **kws)
+    return dict(contact=username, name=validate.name, memory=validate.memory,
+                disksize=validate.disksize, owner=validate.owner, machine_type=validate.vmtype,
+                cdrom=getattr(validate, 'cdrom', None),
+                clone_from=getattr(validate, 'clone_from', None))
+
+def create(username, state, fields):
     """Handler for create requests."""
     try:
-        parsed_fields = parseCreate(user, fields)
-        machine = controls.createVm(**parsed_fields)
+        parsed_fields = parseCreate(username, state, fields)
+        machine = controls.createVm(username, **parsed_fields)
     except InvalidInput, err:
         pass
     else:
         err = None
-    g.clear() #Changed global state
-    d = getListDict(user)
+    state.clear() #Changed global state
+    d = getListDict(username)
     d['err'] = err
     if err:
@@ -195,14 +171,14 @@
 
 
-def getListDict(user):
+def getListDict(username, state):
     """Gets the list of local variables used by list.tmpl."""
     checkpoint.checkpoint('Starting')
-    machines = g.machines
+    machines = state.machines
     checkpoint.checkpoint('Got my machines')
     on = {}
     has_vnc = {}
-    xmlist = g.xmlist
+    xmlist = state.xmlist
     checkpoint.checkpoint('Got uptimes')
-    can_clone = 'ice3' not in g.xmlist_raw
+    can_clone = 'ice3' not in state.xmlist_raw
     for m in machines:
         if m not in xmlist:
@@ -217,17 +193,17 @@
             else:
                 has_vnc[m] = "ParaVM"+helppopup("ParaVM Console")
-    max_memory = validation.maxMemory(user)
-    max_disk = validation.maxDisk(user)
+    max_memory = validation.maxMemory(username, state)
+    max_disk = validation.maxDisk(username)
     checkpoint.checkpoint('Got max mem/disk')
     defaults = Defaults(max_memory=max_memory,
                         max_disk=max_disk,
-                        owner=user,
+                        owner=username,
                         cdrom='gutsy-i386')
     checkpoint.checkpoint('Got defaults')
     def sortkey(machine):
-        return (machine.owner != user, machine.owner, machine.name)
+        return (machine.owner != username, machine.owner, machine.name)
     machines = sorted(machines, key=sortkey)
-    d = dict(user=user,
-             cant_add_vm=validation.cantAddVm(user),
+    d = dict(user=username,
+             cant_add_vm=validation.cantAddVm(username, state),
              max_memory=max_memory,
              max_disk=max_disk,
@@ -238,12 +214,12 @@
     return d
 
-def listVms(user, fields):
+def listVms(username, state, fields):
     """Handler for list requests."""
     checkpoint.checkpoint('Getting list dict')
-    d = getListDict(user)
+    d = getListDict(username, state)
     checkpoint.checkpoint('Got list dict')
     return templates.list(searchList=[d])
 
-def vnc(user, fields):
+def vnc(username, state, fields):
     """VNC applet page.
 
@@ -265,10 +241,10 @@
     echo 1 > /proc/sys/net/ipv4/ip_forward
     """
-    machine = validation.testMachineId(user, fields.getfirst('machine_id'))
+    machine = validation.Validate(username, state, machine_id=fields.getfirst('machine_id')).machine
 
     TOKEN_KEY = "0M6W0U1IXexThi5idy8mnkqPKEq1LtEnlK/pZSn0cDrN"
 
     data = {}
-    data["user"] = user
+    data["user"] = username
     data["machine"] = machine.name
     data["expires"] = time.time()+(5*60)
@@ -283,5 +259,5 @@
     has_vnc = hasVnc(status)
 
-    d = dict(user=user,
+    d = dict(user=username,
              on=status,
              has_vnc=has_vnc,
@@ -342,9 +318,9 @@
     return disk_fields
 
-def command(user, fields):
+def command(username, state, fields):
     """Handler for running commands like boot and delete on a VM."""
     back = fields.getfirst('back')
     try:
-        d = controls.commandResult(user, fields)
+        d = controls.commandResult(username, state, fields)
         if d['command'] == 'Delete VM':
             back = 'list'
@@ -352,5 +328,5 @@
         if not back:
             raise
-        #print >> sys.stderr, err
+        print >> sys.stderr, err
         result = err
     else:
@@ -359,10 +335,10 @@
             return templates.command(searchList=[d])
     if back == 'list':
-        g.clear() #Changed global state
-        d = getListDict(user)
+        state.clear() #Changed global state
+        d = getListDict(username)
         d['result'] = result
         return templates.list(searchList=[d])
     elif back == 'info':
-        machine = validation.testMachineId(user, fields.getfirst('machine_id'))
+        machine = validation.Validate(username, state, machine_id=fields.getfirst('machine_id')).machine
         return ({'Status': '302',
                  'Location': '/info?machine_id=%d' % machine.machine_id},
@@ -371,5 +347,5 @@
         raise InvalidInput('back', back, 'Not a known back page.')
 
-def modifyDict(user, fields):
+def modifyDict(username, state, fields):
     """Modify a machine as specified by CGI arguments.
 
@@ -379,26 +355,18 @@
     transaction = ctx.current.create_transaction()
     try:
-        machine = validation.testMachineId(user, fields.getfirst('machine_id'))
-        owner = validation.testOwner(user, fields.getfirst('owner'), machine)
-        admin = validation.testAdmin(user, fields.getfirst('administrator'),
-                                     machine)
-        contact = validation.testContact(user, fields.getfirst('contact'),
-                                         machine)
-        name = validation.testName(user, fields.getfirst('name'), machine)
+        kws = dict([(kw, fields.getfirst(kw)) for kw in 'machine_id owner admin contact name memory vmtype disksize'.split()])
+        validate = validation.Validate(username, state, **kws)
+        machine = validate.machine
+        print >> sys.stderr, machine, machine.administrator, kws['admin']
         oldname = machine.name
-        command = "modify"
-
-        memory = fields.getfirst('memory')
-        if memory is not None:
-            memory = validation.validMemory(owner, memory, machine, on=False)
-            machine.memory = memory
-
-        vm_type = validation.validVmType(fields.getfirst('vmtype'))
-        if vm_type is not None:
-            machine.type = vm_type
-
-        disksize = validation.testDisk(owner, fields.getfirst('disk'))
-        if disksize is not None:
-            disksize = validation.validDisk(owner, disksize, machine)
+
+        if hasattr(validate, 'memory'):
+            machine.memory = validate.memory
+
+        if hasattr(validate, 'vmtype'):
+            machine.type = validate.vmtype
+
+        if hasattr(validate, 'disksize'):
+            disksize = validate.disksize
             disk = machine.disks[0]
             if disk.size != disksize:
@@ -408,17 +376,18 @@
 
         update_acl = False
-        if owner is not None and owner != machine.owner:
-            machine.owner = owner
+        if hasattr(validate, 'owner') and validate.owner != machine.owner:
+            machine.owner = validate.owner
             update_acl = True
-        if name is not None:
+        if hasattr(validate, 'name'):
             machine.name = name
-        if admin is not None and admin != machine.administrator:
-            machine.administrator = admin
+        if hasattr(validate, 'admin') and validate.admin != machine.administrator:
+            machine.administrator = validate.admin
             update_acl = True
-        if contact is not None:
-            machine.contact = contact
+        if hasattr(validate, 'contact'):
+            machine.contact = validate.contact
 
         ctx.current.save(machine)
         if update_acl:
+            print >> sys.stderr, machine, machine.administrator
             cache_acls.refreshMachine(machine)
         transaction.commit()
@@ -428,22 +397,22 @@
     for diskname in olddisk:
         controls.resizeDisk(oldname, diskname, str(olddisk[diskname]))
-    if name is not None:
-        controls.renameMachine(machine, oldname, name)
-    return dict(user=user,
-                command=command,
+    if hasattr(validate, 'name'):
+        controls.renameMachine(machine, oldname, validate.name)
+    return dict(user=username,
+                command="modify",
                 machine=machine)
 
-def modify(user, fields):
+def modify(username, state, fields):
     """Handler for modifying attributes of a machine."""
     try:
-        modify_dict = modifyDict(user, fields)
+        modify_dict = modifyDict(username, state, fields)
     except InvalidInput, err:
         result = None
-        machine = validation.testMachineId(user, fields.getfirst('machine_id'))
+        machine = validation.Validate(username, state, machine_id=fields.getfirst('machine_id')).machine
     else:
         machine = modify_dict['machine']
         result = 'Success!'
         err = None
-    info_dict = infoDict(user, machine)
+    info_dict = infoDict(username, machine)
     info_dict['err'] = err
     if err:
@@ -454,5 +423,5 @@
 
 
-def helpHandler(user, fields):
+def helpHandler(username, state, fields):
     """Handler for help messages."""
     simple = fields.getfirst('simple')
@@ -497,5 +466,5 @@
         subjects = sorted(help_mapping.keys())
 
-    d = dict(user=user,
+    d = dict(user=username,
              simple=simple,
              subjects=subjects,
@@ -509,5 +478,5 @@
     raise CodeError("Unknown operation")
 
-def infoDict(user, machine):
+def infoDict(username, machine):
     """Get the variables used by info.tmpl."""
     status = controls.statusInfo(machine)
@@ -580,5 +549,5 @@
 
 
-    max_mem = validation.maxMemory(machine.owner, machine, False)
+    max_mem = validation.maxMemory(machine.owner, state, machine, False)
     checkpoint.checkpoint('Got mem')
     max_disk = validation.maxDisk(machine.owner, machine)
@@ -589,5 +558,5 @@
     defaults.disk = "%0.2f" % (machine.disks[0].size/1024.)
     checkpoint.checkpoint('Got defaults')
-    d = dict(user=user,
+    d = dict(user=username,
              on=status is not None,
              machine=machine,
@@ -602,12 +571,12 @@
     return d
 
-def info(user, fields):
+def info(username, state, fields):
     """Handler for info on a single VM."""
-    machine = validation.testMachineId(user, fields.getfirst('machine_id'))
-    d = infoDict(user, machine)
+    machine = validation.Validate(username, state, machine_id=fields.getfirst('machine_id')).machine
+    d = infoDict(username, machine)
     checkpoint.checkpoint('Got infodict')
     return templates.info(searchList=[d])
 
-def unauthFront(_, fields):
+def unauthFront(_, _2, fields):
     """Information for unauth'd users."""
     return templates.unauth(searchList=[{'simple' : True}])
@@ -629,12 +598,14 @@
 
 
-def getUser():
+def getUser(environ):
     """Return the current user based on the SSL environment variables"""
-    email = os.environ.get('SSL_CLIENT_S_DN_Email', None)
+    email = environ.get('SSL_CLIENT_S_DN_Email', None)
     if email is None:
         return None
-    return email.split("@")[0]
-
-def main(operation, user, fields):
+    if not email.endswith('@MIT.EDU'):
+        return None
+    return email[:-8]
+
+def main(operation, username, state, fields):
     start_time = time.time()
     fun = mapping.get(operation, badOperation)
@@ -644,5 +615,5 @@
     try:
         checkpoint.checkpoint('Before')
-        output = fun(u, fields)
+        output = fun(username, state, fields)
         checkpoint.checkpoint('After')
 
@@ -653,4 +624,11 @@
         e = revertStandardError()
         if e:
+            if isinstance(output, basestring):
+                sys.stderr = StringIO()
+                x = str(output)
+                print >> sys.stderr, x
+                print >> sys.stderr, 'XXX'
+                print >> sys.stderr, e
+                raise Exception()
             output.addError(e)
         printHeaders(headers)
@@ -659,5 +637,5 @@
         print output_string
         if fields.has_key('timedebug'):
-            print '<pre>%s</pre>' % checkpoint
+            print '<pre>%s</pre>' % cgi.escape(checkpoint)
     except Exception, err:
         if not fields.has_key('js'):
@@ -665,10 +643,10 @@
                 print 'Content-Type: text/html\n'
                 e = revertStandardError()
-                print error(operation, u, fields, err, e)
+                print error(operation, state.username, fields, err, e)
                 sys.exit(1)
             if isinstance(err, InvalidInput):
                 print 'Content-Type: text/html\n'
                 e = revertStandardError()
-                print invalidInput(operation, u, fields, err, e)
+                print invalidInput(operation, state.username, fields, err, e)
                 sys.exit(1)
         print 'Content-Type: text/plain\n'
@@ -690,6 +668,6 @@
         logging.getLogger('sqlalchemy.orm.unitofwork').setLevel(logging.INFO)
 
-    u = getUser()
-    g.user = u
+    username = getUser(os.environ)
+    state.username = username
     operation = os.environ.get('PATH_INFO', '')
     if not operation:
@@ -697,8 +675,6 @@
         print 'Location: ' + os.environ['SCRIPT_NAME']+'/\n'
         sys.exit(0)
-
-    if u is None:
+    if username is None:
         operation = 'unauth'
-
     if operation.startswith('/'):
         operation = operation[1:]
@@ -708,5 +684,5 @@
     if os.getenv("SIPB_XEN_PROFILE"):
         import profile
-        profile.run('main(operation, u, fields)', 'log-'+operation)
-    else:
-        main(operation, u, fields)
+        profile.run('main(operation, username, state, fields)', 'log-'+operation)
+    else:
+        main(operation, username, state, fields)