Index: package_tags/xvm-console-devconfig/0.3/debian/changelog
===================================================================
--- package_tags/xvm-console-devconfig/0.3/debian/changelog	(revision 690)
+++ package_tags/xvm-console-devconfig/0.3/debian/changelog	(revision 690)
@@ -0,0 +1,17 @@
+xvm-console-devconfig (0.3) unstable; urgency=low
+
+  * fix distribution; gee thanks, Ubuntu dch
+
+ -- Greg Price <price@mit.edu>  Sun, 20 Jul 2008 15:55:35 -0400
+
+xvm-console-devconfig (0.2) intrepid; urgency=low
+
+  * handle diversions correctly
+
+ -- Greg Price <price@mit.edu>  Sun, 20 Jul 2008 15:53:38 -0400
+
+xvm-console-devconfig (0.1) unstable; urgency=low
+
+  * Initial release.
+
+ -- Greg Price <price@mit.edu>  Sun, 20 Jul 2008 00:42:20 -0400
Index: package_tags/xvm-console-devconfig/0.3/debian/compat
===================================================================
--- package_tags/xvm-console-devconfig/0.3/debian/compat	(revision 690)
+++ package_tags/xvm-console-devconfig/0.3/debian/compat	(revision 690)
@@ -0,0 +1,1 @@
+5
Index: package_tags/xvm-console-devconfig/0.3/debian/control
===================================================================
--- package_tags/xvm-console-devconfig/0.3/debian/control	(revision 690)
+++ package_tags/xvm-console-devconfig/0.3/debian/control	(revision 690)
@@ -0,0 +1,17 @@
+Source: xvm-console-devconfig
+Section: servers
+Priority: important
+Maintainer: xvm@mit.edu
+Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 5), config-package-dev (>= 4.5~)
+Standards-Version: 3.7.2
+
+Package: xvm-console-devconfig
+Architecture: all
+Provides: ${diverted-files}
+Conflicts: ${diverted-files}
+Depends: ${shlibs:Depends}, ${misc:Depends}, sipb-xen-console
+Description: XVM serial console server
+ This package should be installed on sipb-xen-console.
+ It makes sure that necessary tools are available.
+ .
+ This is the config package for the dev cluster.
Index: package_tags/xvm-console-devconfig/0.3/debian/control.in
===================================================================
--- package_tags/xvm-console-devconfig/0.3/debian/control.in	(revision 690)
+++ package_tags/xvm-console-devconfig/0.3/debian/control.in	(revision 690)
@@ -0,0 +1,17 @@
+Source: xvm-console-devconfig
+Section: servers
+Priority: important
+Maintainer: xvm@mit.edu
+Build-Depends: @cdbs@
+Standards-Version: 3.7.2
+
+Package: xvm-console-devconfig
+Architecture: all
+Provides: ${diverted-files}
+Conflicts: ${diverted-files}
+Depends: ${shlibs:Depends}, ${misc:Depends}, sipb-xen-console
+Description: XVM serial console server
+ This package should be installed on sipb-xen-console.
+ It makes sure that necessary tools are available.
+ .
+ This is the config package for the dev cluster.
Index: package_tags/xvm-console-devconfig/0.3/debian/copyright
===================================================================
--- package_tags/xvm-console-devconfig/0.3/debian/copyright	(revision 690)
+++ package_tags/xvm-console-devconfig/0.3/debian/copyright	(revision 690)
@@ -0,0 +1,4 @@
+This package was created for the XVM project <xvm@mit.edu> of the MIT
+Student Information Processing Board.
+
+You may use it, etc, under the GNU GPL, version 2 or later.
Index: package_tags/xvm-console-devconfig/0.3/debian/files
===================================================================
--- package_tags/xvm-console-devconfig/0.3/debian/files	(revision 690)
+++ package_tags/xvm-console-devconfig/0.3/debian/files	(revision 690)
@@ -0,0 +1,1 @@
+xvm-console-devconfig_0.2_all.deb servers important
Index: package_tags/xvm-console-devconfig/0.3/debian/rules
===================================================================
--- package_tags/xvm-console-devconfig/0.3/debian/rules	(revision 690)
+++ package_tags/xvm-console-devconfig/0.3/debian/rules	(revision 690)
@@ -0,0 +1,10 @@
+#!/usr/bin/make -f
+
+DEB_AUTO_UPDATE_DEBIAN_CONTROL = 1
+DEB_DIVERT_EXTENSION = .xvm
+DEB_DIVERT_FILES_xvm-console-devconfig += \
+	/etc/conserver/invirt-hosts.cf \
+	/etc/remctl/acl/invirt-console
+
+include /usr/share/cdbs/1/rules/debhelper.mk
+include /usr/share/cdbs/1/rules/config-package.mk
Index: package_tags/xvm-console-devconfig/0.3/debian/xvm-console-devconfig.install
===================================================================
--- package_tags/xvm-console-devconfig/0.3/debian/xvm-console-devconfig.install	(revision 690)
+++ package_tags/xvm-console-devconfig/0.3/debian/xvm-console-devconfig.install	(revision 690)
@@ -0,0 +1,1 @@
+files/* .
Index: package_tags/xvm-console-devconfig/0.3/files/etc/conserver/invirt-hosts.cf.xvm
===================================================================
--- package_tags/xvm-console-devconfig/0.3/files/etc/conserver/invirt-hosts.cf.xvm	(revision 690)
+++ package_tags/xvm-console-devconfig/0.3/files/etc/conserver/invirt-hosts.cf.xvm	(revision 690)
@@ -0,0 +1,2 @@
+#include /etc/conserver/conf.d/black-mesa.mit.edu
+#include /etc/conserver/conf.d/sx-blade-2.mit.edu
Index: package_tags/xvm-console-devconfig/0.3/files/etc/remctl/acl/invirt-console.xvm
===================================================================
--- package_tags/xvm-console-devconfig/0.3/files/etc/remctl/acl/invirt-console.xvm	(revision 690)
+++ package_tags/xvm-console-devconfig/0.3/files/etc/remctl/acl/invirt-console.xvm	(revision 690)
@@ -0,0 +1,2 @@
+host/black-mesa.mit.edu@ATHENA.MIT.EDU
+host/sx-blade-2.mit.edu@ATHENA.MIT.EDU