Index: trunk/packages/sipb-xen-autoinstaller/domU/usr/lib/xen-tools/edgy.d/91-make-fstab
===================================================================
--- trunk/packages/sipb-xen-guest-installer/domU/usr/lib/xen-tools/edgy.d/91-make-fstab	(revision 641)
+++ trunk/packages/sipb-xen-autoinstaller/domU/usr/lib/xen-tools/edgy.d/91-make-fstab	(revision 742)
@@ -1,99 +1,1 @@
-#!/bin/sh
-
-# This is a copy of 90-make-fstab, with a bug fixed.
-# It should be removed once the bug is fixed upstream.
-
-#
-#  This script is responsible for setting up /etc/fstab upon the
-# new instance.
-#
-#  This should be a simple job, but it is complicated by some of the
-# differences between filesystems - some root filesystems will require
-# the installation of new packages, and we have to handle that here.
-#
-# Steve
-# --
-# http://www.steve.org.uk/
-
-
-prefix=$1
-
-#
-#  Source our common functions
-#
-if [ -e /usr/lib/xen-tools/common.sh ]; then
-    . /usr/lib/xen-tools/common.sh
-else
-    . ./hooks/common.sh
-fi
-
-
-#
-# Log our start
-#
-logMessage Script $0 starting
-
-
-#
-# Make sure we use ide style device names if required
-#
-device=sda
-if [ "${ide}" ]; then
-    device=hda
-fi
-
-#
-#  Now we have the options we can create the fstab.
-#
-has_xfs=0
-has_reiserfs=0
-cat <<E_O_FSTAB > ${prefix}/etc/fstab
-# /etc/fstab: static file system information.
-#
-# <file system> <mount point>   <type>  <options>       <dump>  <pass>
-proc            /proc           proc    defaults        0       0
-E_O_FSTAB
-for part in `seq 1 ${NUMPARTITIONS}`; do
-    eval "PARTITION=\"\${PARTITION${part}}\""
-    OLDIFS="${IFS}"
-    IFS=:
-    x=0
-    for partdata in ${PARTITION}; do
-        eval "partdata${x}=\"${partdata}\""
-        x=$(( $x+1 ))
-    done
-    IFS="${OLDIFS}"
-    
-    case "${partdata2}" in
-        xfs)
-            has_xfs=1
-            ;;
-        reiserfs)
-            has_reiserfs=1
-            ;;
-    esac
-    
-    if [ "${partdata2}" = "swap" ]; then
-        echo "${partdata7} none swap sw 0 0" >> ${prefix}/etc/fstab
-    else
-        echo "${partdata7} ${partdata3} ${partdata2} ${partdata4} 0 1" >> ${prefix}/etc/fstab
-    fi
-done
-
-
-#
-#  Finally we can install any required packages for the given root
-# filesystem
-#
-if [ $has_xfs -eq 1 ]; then
-    installDebianPackage ${prefix} xfsprogs
-fi
-if [ $has_reiserfs -eq 1 ]; then
-    installDebianPackage ${prefix} reiserfsprogs
-fi
-
-
-#
-#  Log our finish
-#
-logMessage Script $0 finished
+link ../debian.d/91-make-fstab
Index: trunk/packages/sipb-xen-autoinstaller/domU/usr/lib/xen-tools/patches/common.diff
===================================================================
--- trunk/packages/sipb-xen-guest-installer/domU/usr/lib/xen-tools/patches/common.diff	(revision 641)
+++ trunk/packages/sipb-xen-autoinstaller/domU/usr/lib/xen-tools/patches/common.diff	(revision 742)
@@ -26,13 +26,2 @@
  ## default grub root device
  ## e.g. groot=(hd0,0)
---- /etc/network/interfaces~       2008-06-22 06:47:55.000000000 -0400
-+++ /etc/network/interfaces        2008-06-22 06:49:21.000000000 -0400
-@@ -8,7 +8,7 @@
- # The primary network interface
- auto eth0
- iface eth0 inet dhcp
--# post-up ethtool -K eth0 tx off
-+ pre-up ethtool -K eth0 tx off
- 
- #
- # The commented out line above will disable TCP checksumming which
Index: trunk/packages/sipb-xen-autoinstaller/domU/usr/lib/xen-tools/patches/inittab.diff
===================================================================
--- trunk/packages/sipb-xen-guest-installer/domU/usr/lib/xen-tools/patches/inittab.diff	(revision 641)
+++ 	(revision )
@@ -1,11 +1,0 @@
---- /etc/inittab.orig	2008-05-04 02:48:09.000000000 -0400
-+++ /etc/inittab	2008-05-04 02:52:09.000000000 -0400
-@@ -60,7 +60,7 @@
- 
- # Example how to put a getty on a serial line (for a terminal)
- #
--#T0:23:respawn:/sbin/getty -L ttyS0 9600 vt100
-+T0:23:respawn:/sbin/getty -L ttyS0 9600 vt100
- #T1:23:respawn:/sbin/getty -L ttyS1 9600 vt100
- 
- # Example how to put a getty on a modem line.