Index: package_tags/xvm-devconfig/0.4/debian/changelog
===================================================================
--- package_tags/xvm-devconfig/0.4/debian/changelog	(revision 769)
+++ package_tags/xvm-devconfig/0.4/debian/changelog	(revision 769)
@@ -0,0 +1,23 @@
+xvm-devconfig (0.4) unstable; urgency=low
+
+  * Put host hostnames in values, not keys.
+
+ -- Greg Price <price@mit.edu>  Sun, 27 Jul 2008 23:42:30 -0400
+
+xvm-devconfig (0.3) unstable; urgency=low
+
+  * Add a YAML version with much more info.
+
+ -- Greg Price <price@mit.edu>  Sun, 27 Jul 2008 17:43:33 -0400
+
+xvm-devconfig (0.2) unstable; urgency=low
+
+  * Add postinst to reload config.
+
+ -- Greg Price <price@mit.edu>  Mon, 21 Jul 2008 20:38:59 -0400
+
+xvm-devconfig (0.1) unstable; urgency=low
+
+  * First cut.  Has hosts and realm.
+
+ -- Greg Price <price@mit.edu>  Mon, 21 Jul 2008 18:56:49 -0400
Index: package_tags/xvm-devconfig/0.4/debian/compat
===================================================================
--- package_tags/xvm-devconfig/0.4/debian/compat	(revision 769)
+++ package_tags/xvm-devconfig/0.4/debian/compat	(revision 769)
@@ -0,0 +1,1 @@
+5
Index: package_tags/xvm-devconfig/0.4/debian/control
===================================================================
--- package_tags/xvm-devconfig/0.4/debian/control	(revision 769)
+++ package_tags/xvm-devconfig/0.4/debian/control	(revision 769)
@@ -0,0 +1,14 @@
+Source: xvm-devconfig
+Section: servers
+Priority: important
+Maintainer: xvm@mit.edu
+Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 5)
+Standards-Version: 3.7.2
+
+Package: xvm-devconfig
+Architecture: all
+Provides: invirt-config
+Conflicts: invirt-config
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: XVM dev-cluster config
+  This is the master configuration package for the XVM development cluster.
Index: package_tags/xvm-devconfig/0.4/debian/control.in
===================================================================
--- package_tags/xvm-devconfig/0.4/debian/control.in	(revision 769)
+++ package_tags/xvm-devconfig/0.4/debian/control.in	(revision 769)
@@ -0,0 +1,14 @@
+Source: xvm-devconfig
+Section: servers
+Priority: important
+Maintainer: xvm@mit.edu
+Build-Depends: @cdbs@
+Standards-Version: 3.7.2
+
+Package: xvm-devconfig
+Architecture: all
+Provides: invirt-config
+Conflicts: invirt-config
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: XVM dev-cluster config
+  This is the master configuration package for the XVM development cluster.
Index: package_tags/xvm-devconfig/0.4/debian/copyright
===================================================================
--- package_tags/xvm-devconfig/0.4/debian/copyright	(revision 769)
+++ package_tags/xvm-devconfig/0.4/debian/copyright	(revision 769)
@@ -0,0 +1,4 @@
+This package was created for the XVM project <xvm@mit.edu> of the MIT
+Student Information Processing Board.
+
+You may use it, etc, under the GNU GPL, version 2 or later.
Index: package_tags/xvm-devconfig/0.4/debian/rules
===================================================================
--- package_tags/xvm-devconfig/0.4/debian/rules	(revision 769)
+++ package_tags/xvm-devconfig/0.4/debian/rules	(revision 769)
@@ -0,0 +1,5 @@
+#!/usr/bin/make -f
+
+DEB_AUTO_UPDATE_DEBIAN_CONTROL = 1
+
+include /usr/share/cdbs/1/rules/debhelper.mk
Index: package_tags/xvm-devconfig/0.4/debian/xvm-devconfig.install
===================================================================
--- package_tags/xvm-devconfig/0.4/debian/xvm-devconfig.install	(revision 769)
+++ package_tags/xvm-devconfig/0.4/debian/xvm-devconfig.install	(revision 769)
@@ -0,0 +1,1 @@
+files/* .
Index: package_tags/xvm-devconfig/0.4/debian/xvm-devconfig.postinst
===================================================================
--- package_tags/xvm-devconfig/0.4/debian/xvm-devconfig.postinst	(revision 769)
+++ package_tags/xvm-devconfig/0.4/debian/xvm-devconfig.postinst	(revision 769)
@@ -0,0 +1,41 @@
+#!/bin/sh
+# postinst script
+#
+# see: dh_installdeb(1)
+
+set -e
+set -x
+
+# summary of how this script can be called:
+#        * <postinst> `configure' <most-recently-configured-version>
+#        * <old-postinst> `abort-upgrade' <new version>
+#        * <conflictor's-postinst> `abort-remove' `in-favour' <package>
+#          <new-version>
+#        * <postinst> `abort-remove'
+#        * <deconfigured's-postinst> `abort-deconfigure' `in-favour'
+#          <failed-install-package> <version> `removing'
+#          <conflicting-package> <version>
+# for details, see http://www.debian.org/doc/debian-policy/ or
+# the debian-policy package
+
+
+case "$1" in
+    configure)
+	/usr/sbin/invirt-reload
+    ;;
+
+    abort-upgrade|abort-remove|abort-deconfigure)
+    ;;
+
+    *)
+        echo "postinst called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
+
+# dh_installdeb will replace this with shell code automatically
+# generated by other debhelper scripts.
+
+#DEBHELPER#
+
+exit 0
Index: package_tags/xvm-devconfig/0.4/files/etc/invirt/hosts
===================================================================
--- package_tags/xvm-devconfig/0.4/files/etc/invirt/hosts	(revision 769)
+++ package_tags/xvm-devconfig/0.4/files/etc/invirt/hosts	(revision 769)
@@ -0,0 +1,2 @@
+black-mesa.mit.edu
+sx-blade-2.mit.edu
Index: package_tags/xvm-devconfig/0.4/files/etc/invirt/master.yaml
===================================================================
--- package_tags/xvm-devconfig/0.4/files/etc/invirt/master.yaml	(revision 769)
+++ package_tags/xvm-devconfig/0.4/files/etc/invirt/master.yaml	(revision 769)
@@ -0,0 +1,36 @@
+authn:
+ - type: kerberos
+   realm: ATHENA.MIT.EDU
+
+authz:
+ - type: afs
+   cell: athena.mit.edu
+
+hosts: # hosts on which VMs run
+ - hostname: black-mesa.mit.edu
+   ip: 18.181.0.60
+ - hostname: sx-blade-2.mit.edu
+   ip: 18.181.0.165
+
+db: 
+ uri: postgres://sipb-xen@sipb-xen-dev.mit.edu/sipb_xen
+
+console:
+ hostname: sipb-xen-console.mit.edu
+ ip: 18.181.0.134
+
+remote:
+ hostname: remote.mit.edu
+ ip: 18.181.0.188
+
+dns:
+ domains:  # first one is advertised
+  - xvm.mit.edu
+  - servers.csail.mit.edu
+ nameservers:
+  - hostname: ns1.xvm.mit.edu
+    ip: 18.181.0.62
+ rootip: 18.181.0.62
+
+web:
+ baseuri: https://xvm.mit.edu/
Index: package_tags/xvm-devconfig/0.4/files/etc/invirt/realm
===================================================================
--- package_tags/xvm-devconfig/0.4/files/etc/invirt/realm	(revision 769)
+++ package_tags/xvm-devconfig/0.4/files/etc/invirt/realm	(revision 769)
@@ -0,0 +1,1 @@
+ATHENA.MIT.EDU